﻿using System;
using System.Collections.Generic;
using System.Diagnostics; // Process
using System.IO;
using System.Linq;
using System.Windows.Forms;

namespace ColonYen
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            command_line_info();
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

        public static string[] command_line_info()
        {
            const bool COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const string BASH_PID_BATCH = "C:\\ColonYen\\BASH_PID.bat";
            const string COMMAND = "ColonYen.exe";
            const string COMMAND_PROMPT_PROPERTY_BITMAP = "C:\\ColonYen\\ColonYen\\Resources\\layout.bmp";
            const string COLON_YEN_PDF = "C:\\ColonYen\\ColonYen.pdf";
            const string COLON_YEN_TEXT = "C:\\ColonYen\\ColonYen.txt";
            const string CMD_PID1_BATCH = "C:\\ColonYen\\CMD_PID1.bat";
            const string CMD_PID2_BATCH = "C:\\ColonYen\\CMD_PID2.bat";
            const string LAYOUT_BMP = "C:\\ColonYen\\layout.bmp";
            const string PDF = "-p";
            const string PS_PID_BATCH = "C:\\ColonYen\\PS_PID.bat";
            const string SLOW_TEXT = "C:\\ColonYen\\slow.txt";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            int k = 0;
            int q;
            string fileName = COLON_YEN_TEXT;
            string[] arguments = Environment.GetCommandLineArgs();
            string[] parameters = { "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" };

            foreach (string s in arguments)
            {
                if (k >= parameters.Length)
                {
                    break;
                }

                q = s.IndexOf(COMMAND);
                if (q >= 0)
                {
                    continue;
                }

                switch (s)
                {
                    case PDF:
                        Process p = new Process();
                        p.StartInfo.FileName = COLON_YEN_PDF;
                        p.Start();
                        System.Environment.Exit(0);
                        break;
                    case VERSION_WITH_COMMENTS:
                        versionText(COMMENTS);
                        System.Environment.Exit(0);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        versionText(WITHOUT_COMMENTS);
                        System.Environment.Exit(0);
                        break;
                    default:
                        parameters[k++] = s;
                        break;
                } // switch

            } // foreach

            try
            {
                StreamReader textFile = new StreamReader(fileName, System.Text.Encoding.Default);
                textFile.Close();
            }
            catch (FileNotFoundException e14)
            {
                Error.handler(e14.ToString());

                // COLON_YEN_TEXT
                StreamWriter settingFile = File.CreateText(COLON_YEN_TEXT);
                settingFile.WriteLine("CMD [Start]");
                settingFile.WriteLine(1000);
                settingFile.WriteLine("C:\\ColonYen");
                settingFile.WriteLine(0);
                settingFile.WriteLine(493);
                settingFile.WriteLine(492);
                settingFile.WriteLine(5000);
                settingFile.Close();
            }

            try
            {
                StreamReader textFile = new StreamReader(SLOW_TEXT, System.Text.Encoding.Default);
                textFile.Close();
            }
            catch (FileNotFoundException e15)
            {
                Error.handler(e15.ToString());

                // SLOW_TEXT
                StreamWriter settingFile = File.CreateText(SLOW_TEXT);
                settingFile.WriteLine("600 # TASKLIST /?");
                settingFile.WriteLine("600 # VER");
                settingFile.WriteLine("600 # TASKLIST | FINDSTR \"cmd.exe\"");
                settingFile.WriteLine("600 # bash, cmd, java, powershell");
                settingFile.Close();
            }

            try
            {
                StreamReader batchFile = new StreamReader(CMD_PID1_BATCH, System.Text.Encoding.Default);
                batchFile.Close();
            }
            catch (FileNotFoundException e16)
            {
                Error.handler(e16.ToString());

                // CMD_PID1_BATCH
                StreamWriter settingFile = File.CreateText(CMD_PID1_BATCH);
                settingFile.WriteLine("TASKLIST | FINDSTR \"cmd.exe\" > C:\\ColonYen\\CMD_PID1.txt");
                settingFile.Close();
            }

            try
            {
                StreamReader batchFile = new StreamReader(CMD_PID2_BATCH, System.Text.Encoding.Default);
                batchFile.Close();
            }
            catch (FileNotFoundException e17)
            {
                Error.handler(e17.ToString());

                // CMD_PID2_BATCH
                StreamWriter settingFile = File.CreateText(CMD_PID2_BATCH);
                settingFile.WriteLine("TASKLIST | FINDSTR \"cmd.exe\" > C:\\ColonYen\\CMD_PID2.txt");
                settingFile.Close();
            }

            try
            {
                StreamReader batchFile = new StreamReader(PS_PID_BATCH, System.Text.Encoding.Default);
                batchFile.Close();
            }
            catch (FileNotFoundException e18)
            {
                Error.handler(e18.ToString());

                // PS_PID_BATCH
                StreamWriter settingFile = File.CreateText(PS_PID_BATCH);
                settingFile.WriteLine("TASKLIST | FINDSTR \"powershell.exe\" > C:\\ColonYen\\PS_PID.txt");
                settingFile.Close();
            }

            try
            {
                StreamReader batchFile = new StreamReader(BASH_PID_BATCH, System.Text.Encoding.Default);
                batchFile.Close();
            }
            catch (FileNotFoundException e19)
            {
                Error.handler(e19.ToString());

                // BASH_PID_BATCH
                StreamWriter settingFile = File.CreateText(BASH_PID_BATCH);
                settingFile.WriteLine("TASKLIST | FINDSTR \"bash.exe\" > C:\\ColonYen\\BASH_PID.txt");
                settingFile.Close();
            }

            try
            {
                StreamReader batchFile = new StreamReader(LAYOUT_BMP, System.Text.Encoding.Default);
                batchFile.Close();
            }
            catch (FileNotFoundException e20)
            {
                Error.handler(e20.ToString());

                // LAYOUT_BMP
                try
                {
                    File.Copy(COMMAND_PROMPT_PROPERTY_BITMAP, LAYOUT_BMP);
                }
                catch (DirectoryNotFoundException e21)
                {
                    Error.handler(e21.ToString());
                }

            }

            return parameters;
        }

        public static void versionText(bool comments)
        {
            const double VERSION = 1.02;
            const string EMPTY = " ";
            const string VERSION_TEXT = "version.txt";

            // VERSION_TEXT
            StreamWriter versionFile = File.CreateText(VERSION_TEXT);
            versionFile.Write("ColonYen C# Version ");
            versionFile.WriteLine(VERSION);
            versionFile.WriteLine(EMPTY);

            if (comments)
            {
                versionFile.WriteLine("ColonYen -b25  # 25 lines and a scroll bar");
                versionFile.WriteLine("ColonYen -c3   # Move the ColonYen window to Corner-3.");
                versionFile.WriteLine("ColonYen -e25  # 25 lines");
                versionFile.WriteLine("ColonYen -p    # PDF help ");
                versionFile.WriteLine("ColonYen -s-   # manual start ");
                versionFile.WriteLine("ColonYen -t37  # Wait for 37 milliseconds. ");
                versionFile.WriteLine("ColonYen -w    # Show where the cursor is. ");
                versionFile.WriteLine("ColonYen -V    # version ");
                versionFile.WriteLine("ColonYen -VC   # version with comments ");
            }
            else
            {
                versionFile.WriteLine("ColonYen -b25  ");
                versionFile.WriteLine("ColonYen -c3   ");
                versionFile.WriteLine("ColonYen -e25  ");
                versionFile.WriteLine("ColonYen -p    ");
                versionFile.WriteLine("ColonYen -s-   ");
                versionFile.WriteLine("ColonYen -t37  ");
                versionFile.WriteLine("ColonYen -w    ");
                versionFile.WriteLine("ColonYen -V    ");
                versionFile.WriteLine("ColonYen -VC   ");
            }

            versionFile.Close();
        }

    }
}
